var XLSXEditor = {};
XLSXEditor.sx = 0;
XLSXEditor.sy = 0;
XLSXEditor.ex = 0;
XLSXEditor.ey = 0;
XLSXEditor.sheetRange = [];
XLSXEditor.offsetTop = 0;
XLSXEditor.offsetLeft = 0;
XLSXEditor.offsetBottom = 0;
XLSXEditor.offsetRight = 0;
XLSXEditor.sheetConfigs = [];
XLSXEditor.cellData;
XLSXEditor.defaultMaxSheetNum = 9; //默认最大表个数
XLSXEditor.selectSheetIndex = 0; //默认选择的Sheet
XLSXEditor.defaultFontColor = "#41464b"; //默认字体颜色
XLSXEditor.defaultFontFamily = -1; //默认系统字体
XLSXEditor.defaultBackgroundColor = "#ffffff"; //默认单元格背景颜色
XLSXEditor.sheetAllColNum = sheetCell["column"]; //总列数
XLSXEditor.sheetAllRowNum = sheetCell["row"]; //总行数
XLSXEditor.initCreateSheet = true; //初始化创建Sheet
XLSXEditor.isSelectEditImg = false; //是否编辑图片
XLSXEditor.selectEditImgID = ""; //选择编辑图片ID
XLSXEditor.sheetScales = []; //缩放比例
XLSXEditor.sheetActives = []; //表活跃
XLSXEditor.sheetData;
XLSXEditor.createType = [0, 1]; // 0创建新表， 1导入数据展示
XLSXEditor.cellDataIndex = -1; //选中celldata所在下标
XLSXEditor.setCellValTime = 0;

XLSXEditor.SETSHEETACTIVE = "SETSHEETACTIVE"; //选择获取SHEET
XLSXEditor.SELECTCELLTAG = "SELECTCELLTAG"; //选择单元格下标
XLSXEditor.DBSELECTCELLTAG = "DBSELECTCELLTAG"; //双击选择单元格下标
XLSXEditor.SETCELLVALUE = "SETCELLVALUE"; //设置单元内容
XLSXEditor.GETCELLVALUE = "GETCELLVALUE"; //获取单元内容
XLSXEditor.CLEARCELL = "CLEARCELL"; //清除单元内容
XLSXEditor.SETCELLSTYLES = "SETCELLSTYLES"; //设置单元格格式样式
XLSXEditor.SETRANGEBORDER = "SETRANGEBORDER"; //设置边框线
XLSXEditor.DELETECELL = "DELETECELL"; //删除单元格
XLSXEditor.INSERTROW = "INSERTROW"; //插入行
XLSXEditor.DELETEROW = "DELETEROW"; //删除行
XLSXEditor.DELETECOLUMN = "DELETECOLUMN"; //删除列
XLSXEditor.INSERTCOLUMN = "INSERTCOLUMN"; //插入列
XLSXEditor.SETRANGEMERGE = "SETRANGEMERGE"; //合并单元格
XLSXEditor.CANCELRANGEMERGE = "CANCELRANGEMERGE"; //取消合并单元格
XLSXEditor.SELECTED = "SELECTED"; //选择单元格事件
XLSXEditor.SELECTEDWH = "SELECTEDWH"; //选择区域宽和高
XLSXEditor.SHEETDATA = "SHEETDATA"; //表格数据
XLSXEditor.SETSHEETZOOM = "SETSHEETZOOM"; //缩放
XLSXEditor.SHEETMAXNUM = "SHEETMAXNUM"; //表最大数量
XLSXEditor.SETSHEETNAME = "SETSHEETNAME"; //设置SHEET名称
XLSXEditor.DELSHEET = "DELSHEET"; //删除SHEET
XLSXEditor.SHEETACTIVE = "SHEETACTIVE";

XLSXEditor.startTouch;
XLSXEditor.rowTop = 0;
XLSXEditor.colLeft = 0;
XLSXEditor.isTouch = false;
XLSXEditor.touchType = 0;
XLSXEditor.rowSelectHeight = options.defaultRowHeight;
XLSXEditor.rowSelectAHeight = options.defaultRowHeight;
XLSXEditor.colSelectWidth = options.defaultColWidth;
XLSXEditor.colSelectAWidth = options.defaultColWidth;

XLSXEditor.styles = {};

//删除Sheet表
XLSXEditor.setSheetDelete = function(index) {
    if (!$.trim(index)) {
        return;
    }
    var noOneIndex = getNoActiveOneIndex();
    if (index >= noOneIndex || noOneIndex <= 1) {
        return;
    }

    luckysheet.setSheetClearMoveToLast(index, {
        index: noOneIndex,
        sheetData: {
            "name": getSheetName(XLSXEditor.defaultMaxSheetNum),
            "config": {
                "merge": {
                },
                "borderInfo": [

                ]
            },
            "images": {},
            "index": XLSXEditor.defaultMaxSheetNum,
            "zoomRatio": 1.0,
            "order": XLSXEditor.defaultMaxSheetNum,
            "column": 26,
            "row": 100,
            "status": 1,
            "showGridLines": 1,
            "celldata": [],
            "ch_width": 2361,
            "rh_height": 936,
            "scrollLeft": 0,
            "scrollTop": 0,
        },
        success: function() {
            XLSXEditor.sheetScales.splice(index, 1);
            XLSXEditor.sheetActives.splice(index, 1);
            XLSXEditor.sheetScales.push(1.0);
            XLSXEditor.sheetActives.push(0);
            XLSXEditor.executeCallback(XLSXEditor.DELSHEET, index + "");
            XLSXEditor.getSheetData();
            if (index > 0) {
                XLSXEditor.setSheetIndex(index - 1);
            } else {
                XLSXEditor.setSheetIndex(index, true);
            }
        }
    })
}

//设置Sheet表名称
XLSXEditor.setSheetName = function(index, name) {
    if (!$.trim(index)) {
        index = XLSXEditor.selectSheetIndex;
    }
    if ($.trim(name)) {
        luckysheet.setSheetName(name, {
            order: index,
            index: getNoActiveOneIndex(),
            success: function() {
                var data = {
                    "index": index,
                    "name": name
                };
                XLSXEditor.executeCallback(XLSXEditor.SETSHEETNAME, JSON.stringify(data));
                XLSXEditor.getSheetData();
            }
        });
    }
}

//设置当前选中Sheet
XLSXEditor.setSheetIndex = function(index, isChange = false) {
    if ($.trim(index)) {
        setTimeout(function () {
            luckysheet.setSheetActive(index, {
                isChange: isChange,
                success: function() {
                    XLSXEditor.executeCallback(XLSXEditor.SETSHEETACTIVE, "" + index);
                    XLSXEditor.executeCallback(XLSXEditor.SETSHEETZOOM, XLSXEditor.sheetScales[index]);
                    XLSXEditor.selectSheetIndex = index;
                    if (XLSXEditor.sheetActives[index] === 0) {
                        XLSXEditor.sheetActives[index] = 1;
                    }
                    XLSXEditor.clearRedoUndo();
                    XLSXEditor.executeCallback(XLSXEditor.GETCELLVALUE, luckysheet.getCellValue(XLSXEditor.sy, XLSXEditor.sx));
                    XLSXEditor.styleItems();
                    XLSXEditor.getSheetData();
                }
            });
            if (XLSXEditor.sheetScales[index] < XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex] || index === XLSXEditor.selectSheetIndex) {
                XLSXEditor.selectSheetIndex = index;
                XLSXEditor.setSheetZoom(XLSXEditor.sheetScales[index], 1);
            }
        });
    }
}

//设置单元格内容
XLSXEditor.setCellValue = function(val) {
    if (XLSXEditor.sy >= 0 && XLSXEditor.sx >= 0) {
        if ($.trim(val)) {
            if (val.startsWith("&enter;")) {
                val = " " + val;
            }
            val = changeCellStr(val);
            var txt =  XLSXEditor.getCellValue(XLSXEditor.sy, XLSXEditor.sx);
            if (val != txt) {
                luckysheet.setCellValue(XLSXEditor.sy, XLSXEditor.sx, val, {
                    success: function() {
                        XLSXEditor.executeCallback(XLSXEditor.SETCELLVALUE, val);
                        XLSXEditor.setCellDataVal(val);
                    }
                });
            }
        } else {
            XLSXEditor.clearCell();
        }
    }
}

/**
 * 获取单元格内容
 */
XLSXEditor.getCellValue = function(row, column) {
    if (row < 0 || column < 0) {
        return "";
    }
    return luckysheet.getCellValue(row, column);
}

//清除单元内容
XLSXEditor.clearCell = function() {
    if (XLSXEditor.sy >= 0 && XLSXEditor.sx >= 0) {
        var val =  XLSXEditor.getCellValue(XLSXEditor.sy, XLSXEditor.sx);
        if ($.trim(val)) {
            luckysheet.clearCell(XLSXEditor.sy, XLSXEditor.sx, {
                success: function() {
                    XLSXEditor.executeCallback(XLSXEditor.CLEARCELL, "success");
                    XLSXEditor.setCellDataVal('');
                }
            });
        }
    }
}

// 删除单元格
XLSXEditor.deleteCell = function(move) {
    if (XLSXEditor.sy >= 0 && XLSXEditor.sx >= 0 &&
        XLSXEditor.ey >= 0 && XLSXEditor.ex >= 0) {
        if (!move) {
            move = "left";
        }
        for (var row = XLSXEditor.sy ; row <= XLSXEditor.ey; row++) {
            for (var column = XLSXEditor.ex; column >= XLSXEditor.sx; column--) {
                luckysheet.deleteCell(move, row, column);
            }
        }
        XLSXEditor.executeCallback(XLSXEditor.DELETECELL, "success");
        XLSXEditor.executeCallback(XLSXEditor.GETCELLVALUE, XLSXEditor.getCellValue(XLSXEditor.sy, XLSXEditor.sx));
        XLSXEditor.styleItems();
    }
}

// 设置单元格格式
XLSXEditor.setCellsFormat = function(attr, value) {
    if (!$.trim(attr) || (!$.trim(value) && attr != 'bg')) {
        return;
    }
    if (XLSXEditor.sy >= 0 && XLSXEditor.sx >= 0 &&
        XLSXEditor.ey >= 0 && XLSXEditor.ex >= 0) {
        setTimeout(function () {
            luckysheet.setCellsFormat(attr, value);
            XLSXEditor.styleItems();
        });
    }
}

// 设置单元格格式
XLSXEditor.setCellFormat = function(attr, value) {
    if (!$.trim(attr) || (!$.trim(value) && attr != 'bg')) {
        return;
    }
    if (XLSXEditor.sy >= 0 && XLSXEditor.sx >= 0 &&
        XLSXEditor.ey >= 0 && XLSXEditor.ex >= 0) {
        var rangeStyles = [];
        if (attr == "v") {
            rangeStyles = XLSXEditor.getRangeValue();
        }
        for (var row = XLSXEditor.sy ; row <= XLSXEditor.ey; row++) {
            for (var column = XLSXEditor.sx; column <= XLSXEditor.ex; column++) {
                if (attr == "v") {
                    if (rangeStyles && rangeStyles.length > 0
                        && rangeStyles[row - XLSXEditor.sy] && rangeStyles[row - XLSXEditor.sy].length > 0
                        && !rangeStyles[row- XLSXEditor.sy][column - XLSXEditor.sx]) {
                        luckysheet.setCellFormat(row, column, attr, value);
                    }
                } else {
                    luckysheet.setCellFormat(row, column, attr, value);
                }
            }
        }
        XLSXEditor.styleItems();
    }

}

//插入表格行
XLSXEditor.insertRow = function(direction, num, row) {
    if (!row || row < 0) {
        if (XLSXEditor.sy < 0) {
            return;
        }
        row = XLSXEditor.ey + 1;
        if ($.trim(direction) && parseInt(direction) == 0) {
            row = XLSXEditor.sy;
        }
    }
    if (!num) {
        num = 1;
    }
    setTimeout(function () {
        luckysheet.insertRow(row, {
            number: num,
            success: function() {
                var data = {
                    row: row,
                    num: num
                };
                // XLSXEditor.insertCellFormat();
                XLSXEditor.executeCallback(XLSXEditor.INSERTROW, JSON.stringify(data));
                XLSXEditor.getSheetData();
            }
        });
    });
}

// 删除选中区域所在的行
XLSXEditor.deleteRow = function(rowStart, rowEnd) {
    if (!$.trim(rowStart) || parseInt(rowStart) < 0) {
        if (XLSXEditor.sy < 0) {
            return;
        }
        rowStart = XLSXEditor.sy;
    }

    if (!$.trim(rowEnd) || parseInt(rowEnd) < 0) {
        if (XLSXEditor.ey < 0) {
            return;
        }
        rowEnd = XLSXEditor.ey;
    }
    if (rowStart >=0 && rowEnd >= 0 && rowEnd >= rowStart) {
        luckysheet.deleteRow(rowStart, rowEnd, {
            success: function() {
                XLSXEditor.executeCallback(XLSXEditor.DELETEROW, "success");
                XLSXEditor.executeCallback(XLSXEditor.GETCELLVALUE, XLSXEditor.getCellValue(XLSXEditor.sy, XLSXEditor.sx));
                XLSXEditor.styleItems();
            }
        });
    }
}

//插入表格列
XLSXEditor.insertColumn = function(direction, num, column) {
    if (!column || column < 0) {
        if (XLSXEditor.sx < 0) {
            return;
        }
        column = XLSXEditor.ex + 1;
        if ($.trim(direction) && parseInt(direction) == 0) {
            column = XLSXEditor.sx;
        }
    }
    if (!num) {
        num = 1;
    }
    setTimeout(function () {
        luckysheet.insertColumn(column, {
            number: num,
            success: function() {
                var data = {
                    column: column,
                    num: num
                };
                // XLSXEditor.insertCellFormat();
                XLSXEditor.executeCallback(XLSXEditor.INSERTCOLUMN, JSON.stringify(data));
                XLSXEditor.getSheetData();
            }
        });
    });
}

//删除选中区域所在的列
XLSXEditor.deleteColumn = function(columnStart, columnEnd) {
    if (!$.trim(columnStart) || parseInt(columnStart) < 0) {
        if (XLSXEditor.sx < 0) {
            return;
        }
        columnStart = XLSXEditor.sx;
    }

    if (!$.trim(columnEnd) || parseInt(columnEnd) < 0) {
        if (XLSXEditor.ex < 0) {
            return;
        }
        columnEnd = XLSXEditor.ex;
    }

    if (columnStart >=0 && columnEnd >= 0 && columnEnd >= columnStart) {
        luckysheet.deleteColumn(columnStart, columnEnd, {
            success: function() {
                XLSXEditor.executeCallback(XLSXEditor.DELETECOLUMN, "success");
                XLSXEditor.executeCallback(XLSXEditor.GETCELLVALUE, XLSXEditor.getCellValue(XLSXEditor.sy, XLSXEditor.sx));
                XLSXEditor.styleItems();
            }
        });
    }
}

// 格式化新添加单元格
XLSXEditor.insertCellFormat = function() {
    XLSXEditor.setCellsFormat("v", {"ct": { "fa": "@", "t": "s"},"ht": 1,"vt": 0,"fc": XLSXEditor.defaultFontColor});
}

XLSXEditor.scrollCell = function () {
    // luckysheet.scroll({
    //     scrollTop: XLSXEditor.offsetTop - windowHeight + (options.defaultRowHeight * 3),
    //     scrollLeft: XLSXEditor.offsetLeft - windowWidth + (options.defaultColWidth * 2)
    // });
    var windowHeight = document.documentElement.clientHeight || document.body.clientHeight;
    var scrollTop = $("#luckysheet-cell-main").scrollTop();
    var windowWidth = document.documentElement.clientWidth || document.body.clientWidth;
    var scrollLeft = $("#luckysheet-cell-main").scrollLeft();
    if ((windowHeight + scrollTop) < (XLSXEditor.offsetTop + options.defaultRowHeight * 2) ||
        XLSXEditor.offsetTop < scrollTop ||
        (windowWidth + scrollLeft) < (XLSXEditor.offsetLeft + options.defaultColWidth * 1.5) ||
        XLSXEditor.offsetLeft < scrollLeft) {
        scrollTop = XLSXEditor.offsetTop - windowHeight / 2;
        scrollLeft = XLSXEditor.offsetLeft - windowWidth / 3.1;
        luckysheet.setMobileScroll(false);
        $("#luckysheet-scrollbar-x").scrollLeft(scrollLeft > 0 ? scrollLeft : 0);
        $("#luckysheet-scrollbar-y").scrollTop(scrollTop > 0 ? scrollTop : 0);
    }
}

// 选中区域加粗设置
XLSXEditor.setBold = function () {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("bl", XLSXEditor.getBold(XLSXEditor.getRangeValue()) ? 0 : 1);
    }
}

//获取选中区域是否加粗
XLSXEditor.getBold = function(styles) {
    var isBoldBool = false;
    if (styles && styles.length > 0) {
        isBoldBool = true;
        var len = styles.length;
        for (var i = 0; i < len; i++) {
            if (!isBoldBool) {
                break;
            }
            var size = styles[i].length;
            for (var j = 0; j < size; j++) {
                if (styles[i][j] && !styles[i][j].bl || parseInt(styles[i][j].bl) == 0) {
                    isBoldBool = false;
                    break;
                }
            }
        }
    }
    return isBoldBool;
};

//设置选中区域倾斜
XLSXEditor.setItalic = function () {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("it", XLSXEditor.getItalic(XLSXEditor.getRangeValue()) ? 0 : 1);
    }
}

//获取当前选中是否倾斜
XLSXEditor.getItalic = function(styles) {
    var isItalic = false;
    if (styles && styles.length > 0) {
        isItalic = true;
        var len = styles.length;
        for (var i = 0; i < len; i++) {
            if (!isItalic) {
                break;
            }
            var size = styles[i].length;
            for (var j = 0; j < size; j++) {
                if (styles[i][j] && !styles[i][j].it || parseInt(styles[i][j].it) == 0) {
                    isItalic = false;
                    break;
                }
            }
        }
    }
    return isItalic;
}

//选中区域下划线设置
XLSXEditor.setUnderline = function () {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("un", XLSXEditor.getUnderline(XLSXEditor.getRangeValue()) ? 0 : 1);
    }
}

// 获取选中是否区域下划线
XLSXEditor.getUnderline = function (styles) {
    var isUnderline = false;
    if (styles && styles.length > 0) {
        isUnderline = true;
        var len = styles.length;
        for (var i = 0; i < len; i++) {
            if (!isUnderline) {
                break;
            }
            var size = styles[i].length;
            for (var j = 0; j < size; j++) {
                if (styles[i][j] && !styles[i][j].un || parseInt(styles[i][j].un) == 0) {
                    isUnderline = false;
                    break;
                }
            }
        }
    }
    return isUnderline;
}

//选中区域中划线设置
XLSXEditor.setStrikeThrough = function () {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("cl", XLSXEditor.getStrikeThrough(XLSXEditor.getRangeValue()) ? 0 : 1);
    }
}

// 获取选中区域中划线
XLSXEditor.getStrikeThrough = function (styles) {
    var isStrikeThrough = false;
    if (styles && styles.length > 0) {
        isStrikeThrough = true;
        var len = styles.length;
        for (var i = 0; i < len; i++) {
            if (!isStrikeThrough) {
                break;
            }
            var size = styles[i].length;
            for (var j = 0; j < size; j++) {
                if (styles[i][j] && !styles[i][j].cl || parseInt(styles[i][j].cl) == 0) {
                    isStrikeThrough = false;
                    break;
                }
            }
        }
    }
    return isStrikeThrough;
}

//水平靠左
XLSXEditor.setJustifyLeft = function () {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("ht", 1);
    }
}

//水平居中
XLSXEditor.setJustifyCenter = function () {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("ht", 0);
    }
}

//水平靠右
XLSXEditor.setJustifyRight = function () {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("ht", 2);
    }
}

// 获取水平对齐方式
XLSXEditor.getJustifyType = function (styles) {
    var isCenter = false;
    var isRight = false;
    if (styles && styles.length > 0) {
        isCenter = true;
        isRight = true;
        var len = styles.length;
        for (var i = 0; i < len; i++) {
            if (!isCenter && !isRight) {
                break;
            }
            var size = styles[i].length;
            for (var j = 0; j < size; j++) {
                if (styles[i][j] && !styles[i][j].hasOwnProperty("ht") || parseInt(styles[i][j].ht) == 1) {
                    isCenter = false;
                    isRight = false;
                    break;
                } else if (styles[i][j] && parseInt(styles[i][j].ht) == 0) {
                    isRight = false;
                    if (!isCenter) {
                        break;
                    }
                }  else if (styles[i][j] && parseInt(styles[i][j].ht) == 2) {
                    isCenter = false;
                    if (!isRight) {
                        break;
                    }
                }
            }
        }
    }
    return isCenter ? 0 : (isRight ? 2 : 1);
}

//垂直靠上
XLSXEditor.setVerticalTop = function () {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("vt", 1);
    }
}

//垂直居中
XLSXEditor.setVerticalCenter = function () {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("vt", 0);
    }
}

//垂直靠下
XLSXEditor.setVerticalBottom = function () {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("vt", 2);
    }
}

// 获取水平对齐方式
XLSXEditor.getVerticalType = function (styles) {
    var isTop = false;
    var isBottom = false
    if (styles && styles.length > 0) {
        isTop = true;
        isBottom = true
        var len = styles.length;
        for (var i = 0; i < len; i++) {
            if (!isBottom && !isTop) {
                break;
            }
            var size = styles[i].length;
            for (var j = 0; j < size; j++) {
                if (styles[i][j] && !styles[i][j].hasOwnProperty("vt") || parseInt(styles[i][j].vt) == 0) {
                    isTop = false;
                    isBottom = false;
                    break;
                } else if (styles[i][j] && parseInt(styles[i][j].vt) == 1) {
                    isBottom = false;
                    if (!isTop) {
                        break;
                    }
                }  else if (styles[i][j] && parseInt(styles[i][j].vt) == 2) {
                    isTop = false;
                    if (!isBottom) {
                        break;
                    }
                }
            }
        }
    }
    return isTop ? 1 : (isBottom ? 2 : 0);
}

// 选中区域字体大小设置
XLSXEditor.setFontSize = function (size) {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0 && $.trim(size)) {
        XLSXEditor.setCellsFormat("fs", size);
    }
}

// 获取选中区域字体大小
XLSXEditor.getFontSize = function(styles) {
    var isUnifyFontSize = false;
    var fontSize = options.defaultFontSize;
    if (styles && styles.length > 0) {
        isUnifyFontSize = true;
        var len = styles.length;
        if (styles[0].length > 0 && styles[0][0].hasOwnProperty("fs")) {
            fontSize = parseInt(styles[0][0].fs);
        }
        for (var i = 0; i < len; i++) {
            if (!isUnifyFontSize) {
                break;
            }
            var size = styles[i].length;
            for (var j = 0; j < size; j++) {
                if (styles[i][j] && styles[i][j].hasOwnProperty("fs") && parseInt(styles[i][j].fs) != fontSize) {
                    isUnifyFontSize = false;
                    break;
                } else if (styles[i][j] && !styles[i][j].hasOwnProperty("fs") && options.defaultFontSize != fontSize) {
                    isUnifyFontSize = false;
                    break;
                }
            }
        }
    }
    return isUnifyFontSize ? fontSize : options.defaultFontSize ;
}

//设置字体颜色
XLSXEditor.setFontColor = function (color) {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0 && $.trim(color)) {
        XLSXEditor.setCellsFormat("fc", color);
    }
}

//设置字体
XLSXEditor.setFontFamily = function (index) { //0 Times New Roman、 1 Arial、2 Tahoma 、3 Verdana、4 微软雅黑、5 宋体（Song）、6 黑体（ST Heiti）、7 楷体（ST Kaiti）、 8 仿宋（ST FangSong）、9 新宋体（ST Song）、10 华文新魏、11 华文行楷、12 华文隶书
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0 && $.trim(index)) {
        XLSXEditor.setCellsFormat("ff", index);
    }
}

//设置背景颜色
XLSXEditor.setBackgroundColor = function (color) {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("bg", color);
    }
}

/**
 *回车换行
 */
XLSXEditor.setEnter = function() {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("r", {"ct": { "fa": "@", "t": "inlineStr", "s":[]}, "tb": 2});
    }
}

/**
 * 取消自动换行
 */
XLSXEditor.cancelEnter = function() {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        XLSXEditor.setCellsFormat("r", {"ct": { "fa": "@", "t": "s"}, "tb": 0});
    }
}

//设置选中区域边框线
XLSXEditor.setRangeBorder = function(borderType, borderStyle, borderColor) {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        if (!borderType) {
            borderType = "border-all";
        }
        if (!borderStyle) {
            borderStyle = 1;
        }
        if (!borderColor) {
            borderColor = XLSXEditor.defaultFontColor;
        }
        luckysheet.setCellFormat(XLSXEditor.sy, XLSXEditor.sx, "bd", {borderType: borderType,style: borderStyle, color: borderColor,range: [{column: [XLSXEditor.sx, XLSXEditor.ex], row: [XLSXEditor.sy, XLSXEditor.ey]}]});
        XLSXEditor.getSheetData();
        var data = {
            borderType: borderType,
            borderStyle: borderStyle,
            borderColor: borderColor
        };
        XLSXEditor.executeCallback(XLSXEditor.SETRANGEBORDER,JSON.stringify(data));
    }
}

//合并选择区域单元格
XLSXEditor.setRangeMerge = function() {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0 &&
        (XLSXEditor.ex != XLSXEditor.sx || XLSXEditor.ey != XLSXEditor.sy)) {
        var rangrStyles = XLSXEditor.getRangeValue();
        if (!XLSXEditor.isRangeMerge(rangrStyles)) {
            if (XLSXEditor.getRangeMerge(rangrStyles)) {
                luckysheet.setRangeMerge("all");
            }
            luckysheet.setRangeMerge("all", {
                success: function() {
                    XLSXEditor.setVerticalCenter();
                    XLSXEditor.insertCellFormat();
                    XLSXEditor.styleItems();
                    XLSXEditor.executeCallback(XLSXEditor.SETRANGEMERGE, "success");
                }
            });
        }
    }
}

//取消合并单元格
XLSXEditor.cancelRangeMerge = function() {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0 &&
        (XLSXEditor.ex != XLSXEditor.sx || XLSXEditor.ey != XLSXEditor.sy)) {
        if (XLSXEditor.isRangeMerge(XLSXEditor.getRangeValue())) {
            luckysheet.cancelRangeMerge();
            XLSXEditor.executeCallback(XLSXEditor.CANCELRANGEMERGE, "success");
            XLSXEditor.styleItems();
        }
    }
}

// 获取选中区域是否合并
XLSXEditor.isRangeMerge = function(styles) {
    var isMerge = false;
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0 &&
        (XLSXEditor.ex != XLSXEditor.sx || XLSXEditor.ey != XLSXEditor.sy)) {
        if (styles && styles.length > 0) {
            isMerge = true;
            var len = styles.length;
            for (var i = 0; i < len; i++) {
                if (!isMerge) {
                    break;
                }
                var size = styles[i].length;
                for (var j = 0; j < size; j++) {
                    if (styles[i][j] && !styles[i][j].hasOwnProperty("mc")) {
                        isMerge = false;
                        break;
                    }
                }
            }
        }
    }
    return isMerge;
}

//获取选中区域是否存在合并的单元格
XLSXEditor.getRangeMerge = function(styles) {
    var isMerge = true;
    if (styles && styles.length > 0) {
        isMerge = false;
        var len = styles.length;
        for (var i = 0; i < len; i++) {
            if (isMerge) {
                break;
            }
            var size = styles[i].length;
            for (var j = 0; j < size; j++) {
                if (styles[i][j] && styles[i][j].hasOwnProperty("mc")) {
                    isMerge = true;
                    break;
                }
            }
        }
    }
    return isMerge;
}

//下一个选中单元格
XLSXEditor.setNextCell = function() {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ey >= 0 && XLSXEditor.sx >= 0 && XLSXEditor.ex >= 0) {
        if (XLSXEditor.sy < (XLSXEditor.sheetAllRowNum -1)) {
            XLSXEditor.setRangeShow([XLSXEditor.sy + 1, XLSXEditor.sy + 1], [XLSXEditor.sx, XLSXEditor.sx]);
        }
    }
}

//设置选中区域
XLSXEditor.setRangeShow = function(rows, columns) {
    if (!rows) {
        if (XLSXEditor.sy < 0 || XLSXEditor.ey < 0) {
            return;
        }
        rows = [XLSXEditor.sy, XLSXEditor.ey];
    }
    if (!columns) {
        if (XLSXEditor.sx < 0 || XLSXEditor.ex < 0) {
            return;
        }
        columns = [XLSXEditor.sx, XLSXEditor.ex];
    }
    luckysheet.setRangeShow([{row:rows,column:columns}],{
        success: function() {
            XLSXEditor.scrollCell();
        }
    })
}

/**
 * 删除单元格图片
 */
XLSXEditor.delCellImage = function() {
    if (XLSXEditor.isSelectEditImg && XLSXEditor.selectEditImgID) {
        luckysheet.deleteImage(XLSXEditor.selectEditImgID, {
            success: function() {
                if (XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].images) {
                    delete XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].images[XLSXEditor.selectEditImgID];
                }
                XLSXEditor.getStyleItems();
            }
        });
    }
}

/**
 * 设置单元格图片
 */
XLSXEditor.setCellImage = function(src) {
    if (src) {
        if (!src.startsWith("data:image")) {
            return;
        }
        if (XLSXEditor.isSelectEditImg && XLSXEditor.selectEditImgID) {
            luckysheet.replaceImage(XLSXEditor.selectEditImgID, src, {
                success: function(item) {
                    if (item) {
                        if (!XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].images) {
                            XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].images = {};
                        }
                        XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].images[item.id] = item;
                    }
                    XLSXEditor.getStyleItems();
                }
            });
        } else {
            luckysheet.insertImage(src, {
                success: function(item) {
                    if (item) {
                        if (!XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].images) {
                            XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].images = {};
                        }
                        XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].images[item.id] = item;
                    }
                    XLSXEditor.getStyleItems();
                }
            });
        }
    }
}

//缩放Sheet
XLSXEditor.setSheetZoom = function(scale, isDraw) {
    if ($.trim(scale) && parseFloat(scale) != "NaN") {
        scale = parseFloat(scale);
        isDraw = parseInt(isDraw);
        if (scale > 0.1 && scale < 4.0) {
            if (!isDraw) {
                setHideChangeResize();
                $("#luckysheet-scrollbar-x").hide();
                $("#luckysheet-scrollbar-y").hide();
                $("#luckysheet-image-showBoxs").hide();
                document.getElementsByTagName('body')[0].style.zoom = (1.0 / XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]) * scale;
                XLSXEditor.executeCallback(XLSXEditor.SETSHEETZOOM, scale);
            } else {
                document.getElementsByTagName('body')[0].style.zoom = 1.0;
                luckysheet.setSheetZoom(scale, {
                    success: function() {
                        XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex] = scale;
                        XLSXEditor.executeCallback(XLSXEditor.SETSHEETZOOM, scale);
                        setShowChangeResize();
                        luckysheet.setMobileScroll(false);
                        $("#luckysheet-scrollbar-x").show();
                        $("#luckysheet-scrollbar-y").show();
                        $("#luckysheet-image-showBoxs").show();
                        luckysheet.setImagesZoom(scale);
                    }
                });
            }
        }
    }
}

//保存
XLSXEditor.save = function (contentType) {
    if (!$.trim(contentType)) {
        contentType = 'application/octet-stream';
    }
    if (contentType === 'application/octet-stream') {
        XLSXEditor.saveXlsx(contentType);
    }
}

//保存导出xlsx格式base64数据
XLSXEditor.saveXlsx = async function(contentType) {
    var allSheets = luckysheet.getAllSheets();
    XLSXEditor.getSheetData();
    var base64 = await exportXlsx(allSheets);
    if ($.trim(base64)) {
        XLSXEditor.executeCallback(contentType, base64);
    } else {
        XLSXEditor.executeCallback(contentType, 'fail');
    }
}

//导入
XLSXEditor.importData = function(fileBase64, fileName) {
    if (fileBase64) {
        if (!fileName) {
            fileName = 'Excel' + getTime() + '.xlsx';
        } else {
            if (fileName.lastIndexOf(".xlsx") < 0) {
                fileName = fileName + '.xlsx';
            }
        }
        var buffer = base64ToBuffer(fileBase64);
        var blob = new Blob([buffer], {
            type: "application/octet-stream"
        });
        var file = new window.File(
            [blob],
            fileName,
            { type: blob.type }
        );
        LuckyExcel.transformExcelToLucky(file, function(exportJson, luckysheetfile){
            XLSXEditor.create(XLSXEditor.createType[1], fileName, JSON.stringify(exportJson.sheets));
        });
    }
}

XLSXEditor.styleItems = function (type = 'data') {
    var rangeStyles = XLSXEditor.getRangeValue();
    if (rangeStyles && rangeStyles.length > 0
        && rangeStyles[0] && rangeStyles[0].length > 0
        && rangeStyles[0][0]) {
        XLSXEditor.styles.bold = rangeStyles[0][0].hasOwnProperty("bl") ? (parseInt(rangeStyles[0][0].bl) == 0 ? false : true) : false;
        XLSXEditor.styles.italic = rangeStyles[0][0].hasOwnProperty("it") ? (parseInt(rangeStyles[0][0].it) == 0 ? false : true) : false;
        XLSXEditor.styles.underline = rangeStyles[0][0].hasOwnProperty("un") ? (parseInt(rangeStyles[0][0].un) == 0 ? false : true) : false;
        XLSXEditor.styles.strikeThrough = rangeStyles[0][0].hasOwnProperty("cl") ? (parseInt(rangeStyles[0][0].cl) == 0 ? false : true) : false;
        XLSXEditor.styles.justifyType = rangeStyles[0][0].hasOwnProperty("ht") ? parseInt(rangeStyles[0][0].ht) : 1;
        XLSXEditor.styles.verticalType = rangeStyles[0][0].hasOwnProperty("vt") ? parseInt(rangeStyles[0][0].vt) : 0;
        XLSXEditor.styles.fontSize = rangeStyles[0][0].hasOwnProperty("fs") ? parseInt(rangeStyles[0][0].fs) : options.defaultFontSize;
        XLSXEditor.styles.fontColor = rangeStyles[0][0].hasOwnProperty("fc") ? rangeStyles[0][0].fc : XLSXEditor.defaultFontColor;
        XLSXEditor.styles.fontFamily = rangeStyles[0][0].hasOwnProperty("ff") ? parseInt(rangeStyles[0][0].ff) : XLSXEditor.defaultFontFamily;
        XLSXEditor.styles.backgroundColor = rangeStyles[0][0].hasOwnProperty("bg") ? rangeStyles[0][0].bg : XLSXEditor.defaultBackgroundColor;
        XLSXEditor.styles.merge = XLSXEditor.isRangeMerge(rangeStyles);
        XLSXEditor.styles.redo = luckysheet.isRedo();
        XLSXEditor.styles.undo = luckysheet.isUndo();
        XLSXEditor.styles.rowNum = rangeStyles.length;
        XLSXEditor.styles.columnNum = rangeStyles[0].length;
        XLSXEditor.styles.allRowNum = XLSXEditor.sheetAllRowNum;
        XLSXEditor.styles.allColumnNum = XLSXEditor.sheetAllColNum;
        XLSXEditor.isSelectEditImg = XLSXEditor.isEditImg();
        XLSXEditor.styles.isSelectEditImg = XLSXEditor.isSelectEditImg;
        if (XLSXEditor.sheetAllColNum > rangeStyles[0].length) {
            $("#luckysheet-arrow-resize-row").hide();
            $("#luckysheet-change-size-line").hide();
            $("#luckysheet-rows-change-size").css("opacity", 0);
        }

        if (XLSXEditor.sheetAllRowNum > rangeStyles.length) {
            $("#luckysheet-arrow-resize-col").hide();
            $("#luckysheet-change-size-line").hide();
            $("#luckysheet-cols-change-size").css("opacity", 0);
        }

        XLSXEditor.executeCallback(XLSXEditor.SETCELLSTYLES, JSON.stringify(XLSXEditor.styles));

        if (type === 'data') {
            XLSXEditor.getSheetData();
        }
        XLSXEditor.getCellDataIndex();
    }
}

/**
 * 判断是否选择区域编辑图片
 */
XLSXEditor.isEditImg = function() {
    if (!XLSXEditor.sheetData) {
        return false;
    }
    var images = XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].images || {};
    for(var key in images) {
        if (images[key].rows[0] === XLSXEditor.sy && images[key].rows[1] === XLSXEditor.ey &&
        images[key].columns[0] === XLSXEditor.sx && images[key].columns[1] === XLSXEditor.ex) {
            XLSXEditor.selectEditImgID = images[key].id;
            return true;
        }
    }
    XLSXEditor.selectEditImgID = "";
    return false;
}

/**
 * 设置单元格Cell Data 数据
 */
XLSXEditor.setCellDataVal = function(val) {
    XLSXEditor.setCellValTime = getTimeMilliSecond();
    setTimeout(function () {
        var ms = getTimeMilliSecond();
        if ((ms - XLSXEditor.setCellValTime) >= 150) {
            XLSXEditor.setSheetData({m: val + "", v: val});
            // XLSXEditor.getSheetData();
        }
    }, 150);
}

/**
 * 设置Sheet Data
 */
XLSXEditor.setSheetData = function(vals) {
    if (!XLSXEditor.sheetData || XLSXEditor.cellDataIndex < 0) {
        XLSXEditor.getSheetData();
        return;
    }
    var cell = XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].data[XLSXEditor.sy][XLSXEditor.sx];
    var celld = XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].celldata[XLSXEditor.cellDataIndex];
    for(var key in vals) {
        if ($.trim(vals[key])) {
            cell[key] = vals[key];
            celld.v[key] = vals[key];
        } else {
            delete cell[key][key];
            delete celld.v[key];
        }
    }
    if ($.trim(cell.tb) && parseInt(cell.tb) === 2) {
        if (!cell.ct) {
            cell.ct = { "fa": "@", "t": "inlineStr", "s":[]};
        } else {
            cell.ct.fa = "@";
            cell.ct.t = "inlineStr";
            if (!cell.ct.s || !Array.isArray(cell.ct.s)) {
                cell.ct.s = [];
            }
        }
        cell.ct.s.push({
            "v": $.trim(cell.v) ? cell.v : ($.trim(cell.m) ? cell.m : "")
        });
        celld.v.ct = cell.ct;
    }
    XLSXEditor.executeCallback(XLSXEditor.SHEETDATA, JSON.stringify(XLSXEditor.sheetData));
}

/**
 * 获取选中索引下标
 */
XLSXEditor.getCellDataIndex = function() {
    if (!XLSXEditor.sheetData) {
        return;
    }
    var rowLen = XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].data[XLSXEditor.sy].length;
    var startLen = XLSXEditor.sy * rowLen + XLSXEditor.sx;
    var len = XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].celldata.length;
    var i = startLen < len ? startLen : len - 1;
    for (;i >= 0; i--) {
        if (parseInt(XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].celldata[i]['r']) === XLSXEditor.sy &&
            parseInt(XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex].celldata[i]['c']) === XLSXEditor.sx) {
            XLSXEditor.cellDataIndex = i;
            break;
        }
    }
}

//时时获取表格数据 再修时返回最新表格数据
XLSXEditor.getSheetData = function() {
   setTimeout(function () {
       var sheetData = luckysheet.toJson();
       if (sheetData) {
           XLSXEditor.sheetData = sheetData;
           XLSXEditor.getHandleSheetData();
           XLSXEditor.executeCallback(XLSXEditor.SHEETDATA, JSON.stringify(XLSXEditor.sheetData));
           if (sheetData.data && sheetData.data.length > XLSXEditor.selectSheetIndex
               && sheetData.data[XLSXEditor.selectSheetIndex].data && sheetData.data[XLSXEditor.selectSheetIndex].data.length > 0) {
               XLSXEditor.sheetAllRowNum = sheetData.data[XLSXEditor.selectSheetIndex].data.length;
               XLSXEditor.sheetAllColNum = sheetData.data[XLSXEditor.selectSheetIndex].data[0].length;
           }
       }
   }, 100);
}

/**
 * 处理数据
 */
XLSXEditor.getHandleSheetData = function() {
    var len = XLSXEditor.sheetData.data.length;
    for (var i = 0; i < len; i++) {
        XLSXEditor.sheetData.data[i]['active'] = XLSXEditor.sheetActives[i];
        var rowLen = XLSXEditor.sheetData.data[i].data.length;
        var colLen = rowLen > 0 ? XLSXEditor.sheetData.data[i].data[0].length : 0;
        if (XLSXEditor.sheetData.data[i].config) {
            if (XLSXEditor.sheetData.data[i].config.rowlen) {
                var Rows = {};
                for (var j = 0; j < rowLen; j++) {
                    if (XLSXEditor.sheetData.data[i].config.rowlen[j]) {
                        Rows[j] = XLSXEditor.sheetData.data[i].config.rowlen[j];
                    }
                }
                XLSXEditor.sheetData.data[i].config.rowlen = Rows;
            }
            if (XLSXEditor.sheetData.data[i].config.columnlen) {
                var Cols = {};
                for (var j = 0; j < colLen; j++) {
                    if (XLSXEditor.sheetData.data[i].config.columnlen[j]) {
                        Cols[j] = XLSXEditor.sheetData.data[i].config.columnlen[j];
                    }
                }
                XLSXEditor.sheetData.data[i].config.columnlen = Cols;
            }
        }
    }
}

XLSXEditor.getRangeValue = function() {
    if (XLSXEditor.sy >= 0 && XLSXEditor.ex >= 0) {
        var range = luckysheet.getRangeValue();
        return  range ? range : [];
    }
    return [];
}

XLSXEditor.executeCallback = function (callbackId, params) {
     XLSX.executeCallback(callbackId, params ? params : "");
    // var body = {callbackId:callbackId,body:params};
    // window.webkit.messageHandlers.XLSX.postMessage(body);
}

//选择区域事件
XLSXEditor.select = function (index, sheet) {
    if (!sheet || !Array.isArray(sheet) || sheet.length === 0) {
        return;
    }
    XLSXEditor.executeCallback(XLSXEditor.SELECTED, true);
    executeCellWidthAndHeight(sheet[0].column, sheet[0].row);
    XLSXEditor.sheetRange = sheet;
    XLSXEditor.sx = sheet[0].column[0];
    XLSXEditor.ex = sheet[0].column[1];
    XLSXEditor.sy = sheet[0].row[0];
    XLSXEditor.ey = sheet[0].row[1];
    XLSXEditor.offsetTop = sheet[0].top;
    XLSXEditor.offsetBottom = sheet[0].top + sheet[0].height_move;
    XLSXEditor.offsetLeft = sheet[0].left;
    XLSXEditor.offsetRight = sheet[0].left + sheet[0].width_move;
    var rowHs = luckysheet.getRowHeight([XLSXEditor.sy]);
    XLSXEditor.rowSelectHeight = rowHs[XLSXEditor.sy];
    XLSXEditor.rowSelectAHeight = XLSXEditor.rowSelectHeight;
    if (!XLSXEditor.isCellSetting()) {
        XLSXEditor.insertCellFormat();
    }
    XLSXEditor.executeCallback(XLSXEditor.SELECTCELLTAG, luckysheet.getRangetxt(XLSXEditor.selectSheetIndex,{column:sheet[0].column,row:sheet[0].row}));
    XLSXEditor.executeCallback(XLSXEditor.GETCELLVALUE, XLSXEditor.getCellValue(XLSXEditor.sy, XLSXEditor.sx));
    XLSXEditor.styleItems(XLSXEditor.initCreateSheet ? 'data' : 'select');
    XLSXEditor.initCreateSheet = false;
}

/**
 * 计算选择
 */
function executeCellWidthAndHeight(columns, rows) {
    setTimeout(function () {
        if (!XLSXEditor.sheetData) {
            XLSXEditor.sheetData = luckysheet.toJson();
        }
        if (XLSXEditor.sheetData) {
            var sheet = XLSXEditor.sheetData.data[XLSXEditor.selectSheetIndex];
            var width = getCWidth((sheet.config || {} ).columnlen || {}, columns);
            var height = getRHeight((sheet.config || {} ).rowlen || {}, rows);
            var data = {
                width: width,
                height: height
            };
            XLSXEditor.executeCallback(XLSXEditor.SELECTEDWH, JSON.stringify(data));
        }
    }, 10);
}

//双击单元格事件
XLSXEditor.dblclickSelect = function (index, sheet) {
    if (!sheet || !Array.isArray(sheet) || sheet.length === 0) {
        return;
    }
    XLSXEditor.sheetRange = sheet;
    XLSXEditor.sx = sheet[0].column[0];
    XLSXEditor.ex = sheet[0].column[1];
    XLSXEditor.sy = sheet[0].row[0];
    XLSXEditor.ey = sheet[0].row[1];
    XLSXEditor.offsetTop = sheet[0].top;
    XLSXEditor.offsetBottom = sheet[0].top + sheet[0].height_move;
    XLSXEditor.offsetLeft = sheet[0].left;
    XLSXEditor.offsetRight = sheet[0].left + sheet[0].width_move;
    if (!XLSXEditor.isCellSetting()) {
        XLSXEditor.insertCellFormat();
    }
    XLSXEditor.executeCallback(XLSXEditor.DBSELECTCELLTAG, luckysheet.getRangetxt(XLSXEditor.selectSheetIndex,{column:sheet[0].column,row:sheet[0].row}));
    XLSXEditor.executeCallback(XLSXEditor.GETCELLVALUE, luckysheet.getCellValue(XLSXEditor.sy, XLSXEditor.sx));
    XLSXEditor.styleItems('dblclickSelect');
}

XLSXEditor.onclickRowSelect = function(row) {
    if (!isPhone()) {
        return;
    }
    XLSXEditor.rowTop = row;
    var rowHs = luckysheet.getRowHeight([XLSXEditor.sy]);
    XLSXEditor.rowSelectHeight = rowHs[XLSXEditor.sy];
    XLSXEditor.rowSelectAHeight = XLSXEditor.rowSelectHeight;
    $("#luckysheet-arrow-resize-row").show();
    $("#luckysheet-arrow-resize-row").css("backgroundSize", 21 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
    $("#luckysheet-arrow-resize-row").css("width", 21 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
    $("#luckysheet-arrow-resize-row").css("height", 21 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
    $("#luckysheet-arrow-resize-row").css("left", 23.5 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
    $("#luckysheet-arrow-resize-row").css("top", row - 9 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
    var scrollLeft = $("#luckysheet-cell-main").scrollLeft();
    var winW = $("#luckysheet-cell-main").width();
    $("#luckysheet-change-size-line").css({
        "height": "1px",
        "border-width": "0 0px 1px 0",
        "border-color": sheetThemeColor,
        "top": row - 3,
        "left": 0,
        "width": scrollLeft + winW,
        "display": "block",
        "cursor": "ns-resize",
        "z-index": 16
    });
}

XLSXEditor.onclickColSelect = function(col) {
    if (!isPhone()) {
        return;
    }
    XLSXEditor.colLeft = col;
    var colWs = luckysheet.getColumnWidth([XLSXEditor.sx]);
    XLSXEditor.colSelectWidth = colWs[XLSXEditor.sx];
    XLSXEditor.colSelectAWidth = XLSXEditor.colSelectWidth;
    $("#luckysheet-arrow-resize-col").show();
    $("#luckysheet-arrow-resize-col").css("backgroundSize", 21 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
    $("#luckysheet-arrow-resize-col").css("width", 21 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
    $("#luckysheet-arrow-resize-col").css("height", 21 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
    $("#luckysheet-arrow-resize-col").css("top", 1 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
    $("#luckysheet-arrow-resize-col").css("left", col - 10.5 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
    let scrollTop = $("#luckysheet-cell-main").scrollTop();
    let winH = $("#luckysheet-cell-main").height();
    $("#luckysheet-change-size-line").css({
        "height": winH + scrollTop,
        "border-width": "0 1px 0 0",
        "border-color": sheetThemeColor,
        "top": 0,
        "left": col - 3,
        "width": "1px",
        "display": "block",
        "cursor": "ew-resize",
        "z-index": 16
    });
}

XLSXEditor.onclickImgSelect = function(item) {
    if (item) {
        if (item.rows && item.columns) {
            luckysheet.setRangeShow({row:item.rows,column:item.columns}, {
                success: function () {
                    setTimeout(function () {
                        XLSXEditor.styleItems('onclickImgSelect');
                    }, 100);
                }
            })
        }
    }
}

XLSXEditor.loadSuccess = function() {
    console.log('success');
}

//获取选中区域单元格是否存在未配置参数的
XLSXEditor.isCellSetting = function() {
    var styles = XLSXEditor.getRangeValue();
    var isCellSetting = true;
    if (styles && styles.length > 0) {
        var len = styles.length;
        for (var i = 0; i < len; i++) {
            if (!isCellSetting) {
                break;
            }
            var size = styles[i].length;
            for (var j = 0; j < size; j++) {
                if (!styles[i][j] || !styles[i][j]['ct']) {
                    isCellSetting = false;
                    break;
                }
            }
        }
    }
    return isCellSetting;
}

/**
 * 清除撤销回做
 */
XLSXEditor.clearRedoUndo = function() {
    luckysheet.clearRedoUndo();
}

/**
 * 撤销
 */
XLSXEditor.undo = function() {
    try {
        var undo = luckysheet.undo();
        if (undo && undo.length > 0) {
            XLSXEditor.select(XLSXEditor.selectSheetIndex, undo);
        } else {
            XLSXEditor.getStyleItems();
        }
    } catch (e) {
    }

}

/**
 * 回做
 */
XLSXEditor.redo = function() {
    try {
        var redo = luckysheet.redo();
        if (redo && redo.length > 0) {
            XLSXEditor.select(XLSXEditor.selectSheetIndex, redo);
        } else {
            XLSXEditor.getStyleItems();
        }
    }catch (e) {
    }
}

XLSXEditor.getStyleItems = function() {
    setTimeout(function () {
        XLSXEditor.styleItems();
    }, 500);
}

/**
 * 销毁原有表格
 */
XLSXEditor.destroy = function() {
    luckysheet.destroy();
}

/**
 * 设置表格主题颜色
 */
XLSXEditor.setThemeColor = function(sheetThemeColor, sheetThemeRGBA) {
    if (!sheetThemeColor) {
        sheetThemeColor = "#0188fb";
    }
    if (!sheetThemeRGBA) {
        sheetThemeRGBA = "rgba(1, 136, 251, 0.15)";
    }
    luckysheet.setSheetThemeColor(sheetThemeColor,sheetThemeRGBA);
}

/**
 * 创建
 */
XLSXEditor.create = function(type, title, data) {
    if (!$.trim(type)) {
        type = XLSXEditor.createType[0];
    }
    XLSXEditor.sheetConfigs = [];
    XLSXEditor.sheetScales = [];
    XLSXEditor.sheetActives = [];
    options.hook.rangeSelect = XLSXEditor.select;
    options.hook.dblclickSelect = XLSXEditor.dblclickSelect;
    options.hook.onclickRowSelect = XLSXEditor.onclickRowSelect;
    options.hook.onclickColSelect = XLSXEditor.onclickColSelect;
    options.hook.onclickImgSelect = XLSXEditor.onclickImgSelect;

    options.title = title ? title : ('工作表' + getTime());
    if (parseInt(type) === XLSXEditor.createType[0] || !data) { //创建新表
        XLSXEditor.initSheet();
    } else if (parseInt(type) === XLSXEditor.createType[1]) {
        XLSXEditor.initSheetData(data);
    }
    options.data = XLSXEditor.sheetConfigs;
    XLSXEditor.executeCallback(XLSXEditor.SETSHEETZOOM, XLSXEditor.sheetScales[0]);
    XLSXEditor.executeCallback(XLSXEditor.SHEETMAXNUM, XLSXEditor.defaultMaxSheetNum);
    XLSXEditor.executeCallback(XLSXEditor.SHEETACTIVE, JSON.stringify(XLSXEditor.sheetActives));
    luckysheet.create(options);

    if (isPhone()) {
        $("#luckysheet-rows-h").append("<div id=\"luckysheet-arrow-resize-row\" class=\"luckysheet-arrow-resize-row\"></div>")
        $("#luckysheet-cols-h-c").append("<div id=\"luckysheet-arrow-resize-col\" class=\"luckysheet-arrow-resize-col\"></div>")
        $("#luckysheet-rows-change-size").unbind();
    }
    initMoveRowAndCol();
}

//导入数据初始化
XLSXEditor.initSheetData = function(data) {
    var sheetDatas = [];
    var sheetLen = 0;
    if (data) {
        data = changeJsonStr(data);
        sheetDatas = JSON.parse(data);
        sheetLen = sheetDatas.length;
    }

    XLSXEditor.cellData = XLSXEditor.initCellData();

    if (sheetLen > XLSXEditor.defaultMaxSheetNum) {
        XLSXEditor.defaultMaxSheetNum = sheetLen;
    }

    for (var i = 0; i < sheetLen; i++) {
        var zoomRatio = sheetDatas[i].zoomRatio
        if (zoomRatio) {
            zoomRatio = parseFloat(zoomRatio);
        } else {
            zoomRatio = 1.0;
        }
        var images = {};
        if (sheetDatas[i].images) {
            for(var key in sheetDatas[i].images){
                var rows = sheetDatas[i].images[key].rows || [sheetDatas[i].images[key].fromRow, sheetDatas[i].images[key].toRow];
                var columns = sheetDatas[i].images[key].columns || [sheetDatas[i].images[key].fromCol, sheetDatas[i].images[key].toCol];
                var rowlen = (sheetDatas[i].config || {}).rowlen || {};
                var columnlen = (sheetDatas[i].config || {}).columnlen || {};
                var totalH = getRHeight(rowlen, rows) - 2;
                var totalW = getCWidth(columnlen, columns) - 3;

                var wHBool = totalW / totalH > sheetDatas[i].images[key].originWidth / sheetDatas[i].images[key].originHeight ? true : false;
                var width = wHBool ? totalH * sheetDatas[i].images[key].originWidth / sheetDatas[i].images[key].originHeight : totalW;
                var height = wHBool ? totalH : totalW * sheetDatas[i].images[key].originHeight / sheetDatas[i].images[key].originWidth;
                var left = getImgLeft(columnlen, columns[0]);
                var top = getImgTop(rowlen, rows[0]);

                images[key] = {
                    id: key,
                    type: 2,
                    src: sheetDatas[i].images[key].src,
                    isFixedPos: false,
                    originWidth: sheetDatas[i].images[key].originWidth,
                    originHeight: sheetDatas[i].images[key].originHeight,
                    rows: rows,
                    columns: columns,
                    default: {
                        width: width,
                        height: height,
                        left: left,
                        top: top
                    },
                    crop: {
                        width: width,
                        height: height,
                        left: left,
                        top: top
                    },
                    border: {
                        width: 0,
                        radius: 0,
                        style: "solid",
                        color: "#000"
                    }
                }
            }
        }
        var active = $.trim(sheetDatas[i].active) ? sheetDatas[i].active : 1;
        XLSXEditor.sheetScales.push(zoomRatio);
        XLSXEditor.sheetActives.push(active);
        var config = {
            "merge": {
            },
            "borderInfo": [

            ]
        };
        if (sheetDatas[i].config) {
            if (!sheetDatas[i].config.merge) {
                sheetDatas[i].config.merge = {}
            }
            if (!sheetDatas[i].config.borderInfo) {
                sheetDatas[i].config.borderInfo = {}
            }
            config = sheetDatas[i].config;
        }
        var column = parseInt(sheetDatas[i].column) > 26 ? parseInt(sheetDatas[i].column) : 26;
        var row = parseInt(sheetDatas[i].row) > 100 ? parseInt(sheetDatas[i].row) : 100;
        var showGridLines = $.trim(sheetDatas[i]['showGridLines']) ? sheetDatas[i]['showGridLines'] : 1;
        var scrollLeft = $.trim(sheetDatas[i]['scrollLeft']) ? sheetDatas[i]['scrollLeft'] : 0;
        var scrollTop = $.trim(sheetDatas[i]['scrollTop']) ? sheetDatas[i]['scrollTop'] : 0;
        var celldata = sheetDatas[i].celldata;
        var sheetName = $.trim(sheetDatas[i]['name']) ? sheetDatas[i]['name'] : getSheetName(i);
        if (celldata) {
            var cellLen = celldata.length;
            for (var j = 0; j < cellLen; j++) {
                if (celldata[j]['v']) {
                    if (!celldata[j]['v']['ct']) {
                        celldata[j]['v']['ct'] = {
                            "fa": "@",
                            "t": "s"
                        };
                    }
                }
            }
        }
        XLSXEditor.sheetConfigs.push({
            "name": sheetName,
            "config": config,
            "images": images,
            "index": i,
            "zoomRatio": zoomRatio,
            "order": i,
            "column": column,
            "row": row,
            "status": 1,
            "showGridLines": showGridLines,
            "celldata": celldata ? celldata : initcelldata,
            "ch_width": 2361,
            "rh_height": 936,
            "scrollLeft": scrollLeft,
            "scrollTop": scrollTop,
        });
    }
    if (sheetLen < XLSXEditor.defaultMaxSheetNum) {
        for (var i = sheetLen; i < XLSXEditor.defaultMaxSheetNum; i++) {
            XLSXEditor.sheetScales.push(1.0);
            XLSXEditor.sheetActives.push(i === 0 ? 1 : 0);
            XLSXEditor.sheetConfigs.push({
                "name": getSheetName(i),
                "config": {
                    "merge": {
                    },
                    "borderInfo": [

                    ]
                },
                "images": {},
                "index": i,
                "zoomRatio": 1.0,
                "order": i,
                "column": 26,
                "row": 100,
                "status": 1,
                "showGridLines": 1,
                "celldata": i == 0 ? XLSXEditor.cellData : [],
                "ch_width": 2361,
                "rh_height": 936,
                "scrollLeft": 0,
                "scrollTop": 0,
            });
        }
    }
}

function getImgTop(rowlen, row) {
    var totalLT = 0;
    for (var i = 0;i < row; i++) {
        totalLT = totalLT + (rowlen[i] || options.defaultRowHeight);
    }
    return totalLT  + row + 1;
}

/**
 * 获取图片左边位置
 */
function getImgLeft(columnlen, col) {
    var totalL = 0;
    for (var i = 0;i < col; i++) {
        totalL = totalL + (columnlen[i] || options.defaultColWidth);
    }
    return totalL + col + 2;
}

/**
 * 获取列总宽
 */
function getCWidth(columnlen, columns) {
    var totalW = 0;
    for (var col = columns[0]; col <= columns[1]; col++) {
        totalW = totalW + (columnlen[col] || options.defaultColWidth);
    }
    return totalW;
}

/**
 * 获取行总高
 */
function getRHeight(rowlen, rows) {
    var totalH = 0;
    for (var row = rows[0]; row <= rows[1]; row++) {
        totalH = totalH + (rowlen[row] || options.defaultRowHeight);
    }
    return totalH;
}

//初始化表格配置参数
XLSXEditor.initSheet = function() {
    XLSXEditor.cellData = XLSXEditor.initCellData();
    for (var i = 0; i < XLSXEditor.defaultMaxSheetNum; i++) {
        XLSXEditor.sheetScales.push(1.0);
        XLSXEditor.sheetActives.push(i === 0 ? 1 : 0);
        XLSXEditor.sheetConfigs.push({
            "name": "Sheet" + (i + 1),
            "config": {
                "merge": {
                },
                "borderInfo": [

                ]
            },
            "images": {},
            "index": i,
            "zoomRatio": 1.0,
            "order": i,
            "column": 26,
            "row": 100,
            "status": 1,
            "showGridLines": 1,
            "celldata": i == 0 ? XLSXEditor.cellData : [],
            "ch_width": 2361,
            "rh_height": 936,
            "scrollLeft": 0,
            "scrollTop": 0,
        });
    }
}

//初始CellData数据
XLSXEditor.initCellData = function() {
    var celldata = [];
    for (var i = 0; i < sheetCell["row"]; i ++) {
        for (var j = 0; j < sheetCell["column"]; j++) {
            celldata.push({
                "r": i,
                "c": j,
                "v": {
                    "ct": { //单元格值格式
                        "fa": "@",  //格式名称为自动格式
                        "t": "s" //格式类型为数字类型
                    },
                    "ht": 1,
                    "vt": 0,
                    "fc": XLSXEditor.defaultFontColor
                }
            });
        }
    }
    return celldata;
}

$(document).ready(function () {
});


function initMoveRowAndCol() {
    if (isPhone()) {
        $("#luckysheet-arrow-resize-row").on("touchstart", function (e) {
            XLSXEditor.startTouch = e.originalEvent.targetTouches[0];
            XLSXEditor.isTouch = true;
            XLSXEditor.touchType = 1;
            $("#luckysheet-scrollbar-x").hide();
            $("#luckysheet-scrollbar-y").hide();
            $("#luckysheet-rows-change-size").css("opacity", 1);
            $("#luckysheet-rows-change-size").css("background", sheetThemeColor);
            $("#luckysheet-rows-change-size").css("top", XLSXEditor.rowTop - 1);
            $("#luckysheet-change-size-line").css("top", XLSXEditor.rowTop - 1);
        });
        $("#luckysheet-arrow-resize-col").on("touchstart", function (e) {
            XLSXEditor.startTouch = e.originalEvent.targetTouches[0];
            XLSXEditor.isTouch = true;
            XLSXEditor.touchType = 2;
            $("#luckysheet-scrollbar-x").hide();
            $("#luckysheet-scrollbar-y").hide();
            $("#luckysheet-cols-change-size").css("opacity", 1);
            $("#luckysheet-cols-change-size").css("background", sheetThemeColor);
            $("#luckysheet-cols-change-size").css("left", XLSXEditor.colLeft - 2);
            $("#luckysheet-change-size-line").css("left", XLSXEditor.colLeft - 1);
        });
        $("#mysheet").on("touchstart", function (e) {
            if (XLSXEditor.isTouch) {
                $("#luckysheet-change-size-line").show();
            }
        });
        $("#mysheet").on("touchmove", function (e) {
            if (XLSXEditor.startTouch && XLSXEditor.isTouch ) {
                if (XLSXEditor.touchType == 1) {
                    if ((XLSXEditor.rowTop - (XLSXEditor.startTouch.pageY - e.originalEvent.targetTouches[0].pageY)) >
                        (XLSXEditor.rowTop - XLSXEditor.rowSelectHeight * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex])) {
                        var top = XLSXEditor.rowTop - (XLSXEditor.startTouch.pageY - e.originalEvent.targetTouches[0].pageY);
                        $("#luckysheet-change-size-line").css("top", top);
                        $("#luckysheet-rows-change-size").css( "top", top + 1 );
                        XLSXEditor.rowSelectAHeight = (top - XLSXEditor.rowTop) / XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]  + XLSXEditor.rowSelectHeight;
                    }
                } else if (XLSXEditor.touchType == 2) {
                    if ((XLSXEditor.colLeft - (XLSXEditor.startTouch.pageX - e.originalEvent.targetTouches[0].pageX)) >
                        (XLSXEditor.colLeft - XLSXEditor.colSelectWidth * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex])) {
                        var left = XLSXEditor.colLeft - (XLSXEditor.startTouch.pageX - e.originalEvent.targetTouches[0].pageX);
                        $("#luckysheet-change-size-line").css("left", left);
                        $("#luckysheet-cols-change-size").css( "left", left - 1 );
                        XLSXEditor.colSelectAWidth = (left - XLSXEditor.colLeft) / XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex] + XLSXEditor.colSelectWidth;
                    }
                }
            }
        });
        $("#mysheet").on("touchcancel", function (e) {
            setInitRow();
        });
        $("#mysheet").on("touchend", function (e) {
            setInitRow();
        });
    }
}

function setInitRow() {
    if (XLSXEditor.isTouch) {
        $("#luckysheet-change-size-line").hide();
        $("#luckysheet-rows-change-size").css("opacity", 0);
        $("#luckysheet-cols-change-size").css("opacity", 0);
        luckysheet.setMobileScroll(false);
        $("#luckysheet-scrollbar-x").show();
        $("#luckysheet-scrollbar-y").show();
        if (XLSXEditor.touchType == 1) {
            var rowInfo = {};
            rowInfo[XLSXEditor.sy] = XLSXEditor.rowSelectAHeight;
            XLSXEditor.rowTop = XLSXEditor.rowTop + (XLSXEditor.rowSelectAHeight - XLSXEditor.rowSelectHeight) * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex];
            XLSXEditor.rowSelectHeight = XLSXEditor.rowSelectAHeight;
            luckysheet.setRowHeight(rowInfo);
            $("#luckysheet-arrow-resize-row").css("top", XLSXEditor.rowTop - 9 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-rows-h-hover").css("height", XLSXEditor.rowSelectHeight * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
        } else if (XLSXEditor.touchType == 2) {
            var colInfo = {};
            colInfo[XLSXEditor.sx] = XLSXEditor.colSelectAWidth;
            XLSXEditor.colLeft = XLSXEditor.colLeft + (XLSXEditor.colSelectAWidth - XLSXEditor.colSelectWidth) * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex];
            XLSXEditor.colSelectWidth = XLSXEditor.colSelectAWidth;
            luckysheet.setColumnWidth(colInfo);
            $("#luckysheet-arrow-resize-col").css("left", XLSXEditor.colLeft - 10.5 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-cols-h-hover").css("width", XLSXEditor.colSelectWidth * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
        }
    }
    if(XLSXEditor.isTouch) {
        XLSXEditor.getSheetData();
    }
    XLSXEditor.touchType = 0;
    XLSXEditor.startTouch = null;
    XLSXEditor.isTouch = false;
}


function setHideChangeResize() {
    $("#luckysheet-cell-selected-boxs").hide();
    $("#luckysheet-arrow-resize-row").hide();
    $("#luckysheet-change-size-line").hide();
    $("#luckysheet-rows-change-size").css("opacity", 0);
    $("#luckysheet-arrow-resize-col").hide();
    $("#luckysheet-cols-change-size").css("opacity", 0);
}

function setShowChangeResize() {
    $("#luckysheet-cell-selected-boxs").show();
    var rangeStyles = XLSXEditor.getRangeValue();
    if (rangeStyles && rangeStyles.length > 0
        && rangeStyles[0] && rangeStyles[0].length > 0
        && rangeStyles[0][0]) {
        if (XLSXEditor.sheetAllColNum == rangeStyles[0].length) {
            XLSXEditor.rowTop = parseInt($("#luckysheet-cell-selected").css("top")) + XLSXEditor.rowSelectHeight * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex];
            $("#luckysheet-arrow-resize-row").show();
            $("#luckysheet-arrow-resize-row").css("backgroundSize", 21 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-arrow-resize-row").css("width", 21 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-arrow-resize-row").css("height", 21 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-arrow-resize-row").css("left", 23.5 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-arrow-resize-row").css("top", XLSXEditor.rowTop - 9 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-rows-h-hover").css("height", XLSXEditor.rowSelectHeight * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-rows-h-hover").css("top", XLSXEditor.rowTop - XLSXEditor.rowSelectHeight * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
        }

        if (XLSXEditor.sheetAllRowNum == rangeStyles.length) {
            XLSXEditor.colLeft = parseInt($("#luckysheet-cell-selected").css("left")) + XLSXEditor.colSelectWidth * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex];
            $("#luckysheet-arrow-resize-col").show();
            $("#luckysheet-arrow-resize-col").css("backgroundSize", 21 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-arrow-resize-col").css("width", 21 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-arrow-resize-col").css("height", 21 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-arrow-resize-col").css("top", 1 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-arrow-resize-col").css("left", XLSXEditor.colLeft - 10.5 * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-cols-h-hover").css("width", XLSXEditor.colSelectWidth * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
            $("#luckysheet-cols-h-hover").css("left", XLSXEditor.colLeft - XLSXEditor.colSelectWidth * XLSXEditor.sheetScales[XLSXEditor.selectSheetIndex]);
        }
    }
}

/**
 * 获取Sheet表名称
 */
function getSheetName(index) {
    var sheetName = "Sheet" + (index + 1);
    var len = XLSXEditor.sheetConfigs.length;
    for (var i = 1; i < len + 2; i++) {
        sheetName = "Sheet" + (index + i);
        var j = 0;
        for (;j < len; j++) {
            if (XLSXEditor.sheetConfigs[j]['name'] === sheetName) {
                break;
            }
        }
        if (j === len) {
            break;
        }
    }
    return sheetName;
}

/**
 * 最后活动表下标
 */
function getNoActiveOneIndex() {
    var len = XLSXEditor.sheetActives.length;
    for (var i = 0; i < len; i++) {
        if (XLSXEditor.sheetActives[i] === 0) {
            return i;
        }
    }
    return len;
}


/*function getSheetIndex(index) {
    if (!XLSXEditor.sheetData) {
        XLSXEditor.sheetData = luckysheet.toJson();
    }
    return XLSXEditor.sheetData[index]['index'];
}*/
