var options = {
    lang: 'zh', // 设定表格语言
    container: 'mysheet', //luckysheet is the container id
    showinfobar: false,
    showtoolbar: false,
    showsheetbar: false,
    showstatisticBar: false,
    sheetFormulaBar: false,
    enableAddRow: false, //隐藏底部添加功能
    enableAddBackTop: false, //隐藏底部回到顶部功能
    editMode: true, //表格不可编辑
    enablePage: false,
    columnHeaderHeight: 24, //头部行高
    defaultRowHeight: 24,//行高
    defaultColWidth: 75, //列宽
    defaultFontSize: 10, //字体大小
    data: [],
    hook:{
        rowTitleCellRenderBefore:function(rowNum,postion,ctx){
            // console.log("rowTitleCellRenderBefore");
            // console.log(rowNum);
        },
        rowTitleCellRenderAfter:function(rowNum,postion,ctx){
            // console.log("rowTitleCellRenderAfter");
            // console.log(ctx);
        },
        columnTitleCellRenderBefore:function(columnAbc,postion,ctx){
            // console.log("columnTitleCellRenderBefore");
            // console.log(columnAbc);
        },
        columnTitleCellRenderAfter:function(columnAbc,postion,ctx){
            // console.log("columnTitleCellRenderAfter");
            // console.log(postion);
        },
        cellRenderBefore:function(cell,postion,sheetFile,ctx){
            // console.log("cellRenderBefore");
            // console.log(cell,postion,sheetFile,ctx);
        },
        cellRenderAfter:function(cell,postion,sheetFile,ctx){
            // console.log("cellRenderAfter");
            // console.log(postion);
        },
        cellMousedownBefore:function(cell,postion,sheetFile,ctx){
            // console.log("cellMousedownBefore");
            // console.log(postion);
            // console.log(cell);
        },
        cellMousedown:function(cell,postion,sheetFile,ctx){
            // console.log("cellMousedown");
            // console.log(postion);
            // console.log(cell);
            // console.log(sheetFile);
        },
        sheetMousemove:function(cell,postion,sheetFile,moveState,ctx){
            // console.log("sheetMousemove");
            // console.log(cell,postion,sheetFile,moveState,ctx);
        },
        sheetMouseup:function(cell,postion,sheetFile,moveState,ctx){ //鼠标按钮释放事件
            // console.log("sheetMouseup");
            // console.log(cell,postion,sheetFile,moveState,ctx);
        },
        cellAllRenderBefore:function(data,sheetFile,ctx){
            // console.log("cellAllRenderBefore");
            // console.info(data,sheetFile,ctx)
        },
        updated:function(operate){
            // console.log("updated");
            // console.info(operate)
        },
        cellUpdateBefore:function(r,c,value,isRefresh){
            // console.log("cellUpdateBefore");
            // console.info('cellUpdateBefore',r,c,value,isRefresh)
        },
        cellUpdated:function(r,c,oldValue, newValue, isRefresh){
            // console.log("cellUpdated");
            // console.info('cellUpdated',r,c,oldValue, newValue, isRefresh)
        },
        sheetActivate:function(index, isPivotInitial, isNewSheet){
            // console.log("sheetActivate");
            // console.info(index, isPivotInitial, isNewSheet)
        },
        rangeSelect:function(index, sheet){ // 框选或者设置选区后触发

        },
        dblclickSelect: function(index, sheet){ // 框选或者设置选区后触发
            // console.log("dblclickSelect",index, sheet);
        },
        onclickRowSelect: function(row) {
        },
        onclickImgSelect: function(item) {},
        commentInsertBefore:function(r, c){
            // console.log("commentInsertBefore");
            // console.info(r, c)
        },
        commentInsertAfter:function(r, c, cell){
            // console.log("commentInsertAfter");
            // console.info(r, c, cell)
        },
        commentDeleteBefore:function(r, c, cell){
            // console.log("commentDeleteBefore");
            // console.info(r, c, cell)
        },
        commentDeleteAfter:function(r, c, cell){
            // console.log("commentDeleteAfter");
            // console.info(r, c, cell)
        },
        commentUpdateBefore:function(r, c, value){
            // console.log("commentUpdateBefore");
            // console.info(r, c, value)
        },
        commentUpdateAfter:function(r, c, oldCell, newCell ){
            // console.log("commentUpdateAfter");
            // console.info(r, c, oldCell, newCell)
        },


    }
}
